/*!
 * frest-json 0.11.0 - https://github.com/panjiesw/frest
 * © 2018 Panjie Setiawan Wicaksono
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
!function(e,n){"object"==typeof exports&&"object"==typeof module?module.exports=n():"function"==typeof define&&define.amd?define([],n):"object"==typeof exports?exports.frestJson=n():e.frestJson=n()}(window,function(){return function(e){var n={};function t(r){if(n[r])return n[r].exports;var o=n[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,t),o.l=!0,o.exports}return t.m=e,t.c=n,t.d=function(e,n,r){t.o(e,n)||Object.defineProperty(e,n,{enumerable:!0,get:r})},t.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},t.t=function(e,n){if(1&n&&(e=t(e)),8&n)return e;if(4&n&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(t.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&n&&"string"!=typeof e)for(var o in e)t.d(r,o,function(n){return e[n]}.bind(null,o));return r},t.n=function(e){var n=e&&e.__esModule?function(){return e.default}:function(){return e};return t.d(n,"a",n),n},t.o=function(e,n){return Object.prototype.hasOwnProperty.call(e,n)},t.p="",t(t.s=1)}([function(e,n,t){"use strict";
/*!
 * is-plain-object <https://github.com/jonschlinkert/is-plain-object>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */var r=t(2);function o(e){return!0===r(e)&&"[object Object]"===Object.prototype.toString.call(e)}e.exports=function(e){var n,t;return!1!==o(e)&&("function"==typeof(n=e.constructor)&&(!1!==o(t=n.prototype)&&!1!==t.hasOwnProperty("isPrototypeOf")))}},function(e,n,t){"use strict";t.r(n);var r="json:request",o="json:response",i="json:error";function u(e){void 0===e&&(e={});var n=function(n){return new Promise(function(t,r){var i=e.force,u=e.headerContent,c=e.transform,s=n.request.skip,f=n.response,d=f.origin,p=f.body,a=d.headers,y=d.bodyUsed,l=d.status,b=a.get("Content-Type");if(y||s&&!(s.indexOf(o)<0)||!(b&&b.indexOf(u||"application/json")>=0||i))t({origin:d,body:p});else{(c?c(d).then(function(e){return JSON.parse(e)}).then(function(e){t({origin:d,body:e})}):d.json().then(function(e){t({origin:d,body:e})})).catch(function(e){l>=201&&l<=204?t({origin:d}):r(e)})}})};return Object.defineProperty(n,"id",{value:o}),n}
/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */Object.setPrototypeOf||Array;var c=Object.assign||function(e){for(var n,t=1,r=arguments.length;t<r;t++)for(var o in n=arguments[t])Object.prototype.hasOwnProperty.call(n,o)&&(e[o]=n[o]);return e};var s=t(0),f=t.n(s);function d(e){void 0===e&&(e={});var n=function(n){return new Promise(function(t,o){try{var i=e.headerAccept,u=e.headerContent,s=e.method,d=n.request,p=d.body,a=d.method,y=d.headers,l=d.skip,b=n.request.body;(!s||s.indexOf(a)>-1)&&(!l||l.indexOf(r)<0)&&(f()(p)&&(b=JSON.stringify(p),y.set("Content-Type",u||"application/json")),y.append("Accept",i||"application/json")),t(c({},n.request,{headers:y,body:b}))}catch(e){o(e)}})};return Object.defineProperty(n,"id",{value:r}),n}function p(e){void 0===e&&(e={});var n=function(n){return new Promise(function(t,r){var o=e.headerContent,u=n.response,c=n.request.skip;if(u){var s=u.origin,f=s.headers,d=s.bodyUsed,p=f.get("Content-Type");if(p&&p.indexOf(o||"application/json")>=0&&(!c||c.indexOf(i)<0)&&!d)return void u.origin.json().then(function(e){u.body=e,n.response=u,r(n)})}t(null)})};return Object.defineProperty(n,"id",{value:i}),n}function a(e){return void 0===e&&(e={}),{error:e.error?p(e.error):void 0,request:e.request?d(e.request):void 0,response:e.response?u(e.response):void 0}}t.d(n,"ID_REQUEST",function(){return r}),t.d(n,"ID_RESPONSE",function(){return o}),t.d(n,"ID_ERROR",function(){return i}),t.d(n,"responseInterceptor",function(){return u}),t.d(n,"requestInterceptor",function(){return d}),t.d(n,"errorInterceptor",function(){return p}),t.d(n,"interceptors",function(){return a})},function(e,n,t){"use strict";
/*!
 * isobject <https://github.com/jonschlinkert/isobject>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */e.exports=function(e){return null!=e&&"object"==typeof e&&!1===Array.isArray(e)}}])});